//+------------------------------------------------------------------+
//|                                               CyclePeriod_v2.mq4 |
//|                             Copyright  2008-11, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008-11, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  LightBlue
#property indicator_width1  2
#property indicator_minimum 0

//---- input parameters
extern int     Price=   4;
extern double  Alfa =0.07;

//---- indicator buffers
double cPeriod[];

double Smooth[], Cycle[], DeltaPhase[];
double Q1[2],I1[2],iPeriod[2];
int    prevbars;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name;
//---- indicator line
   SetIndexBuffer(0,cPeriod); SetIndexStyle(0,DRAW_LINE);
      
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="CyclePeriod("+Price+","+DoubleToStr(Alfa,3)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Period");
   
//----
   SetIndexDrawBegin(0,7);
   
   return(0);
}

//+------------------------------------------------------------------+
//| CyclePeriod_v2                                                   |
//+------------------------------------------------------------------+
int start()
{
   int    i, shift, limit, counted_bars=IndicatorCounted();
   
   
   if(ArraySize(Smooth) != Bars) 
   {
   ArraySetAsSeries(Smooth, false); ArrayResize(Smooth, Bars); ArraySetAsSeries(Smooth, true);
   ArraySetAsSeries(Cycle, false); ArrayResize(Cycle, Bars); ArraySetAsSeries(Cycle, true);
   ArraySetAsSeries(DeltaPhase, false); ArrayResize(DeltaPhase, Bars); ArraySetAsSeries(DeltaPhase, true);
   }
   
   
   if (counted_bars > 0) limit=Bars-counted_bars-1;
   if (counted_bars < 1) 
   {
   limit=Bars-1; 
   for(i=0;i<limit;i++) cPeriod[i] = 0;
   }
//----

   for(shift=limit;shift>=0;shift--)
   {	
      if(prevbars != Bars && counted_bars > 0 && shift == 0)
      {
      Q1[1] = Q1[0];
      I1[1] = I1[0];
      iPeriod[1] = iPeriod[0];
      prevbars   = Bars;
      }   

   Smooth[shift] = (aPrice(0,shift) + 2*aPrice(1,shift)+ 2*aPrice(2,shift) + aPrice(3,shift))/6;   
	Cycle [shift] = (1 - 0.5*Alfa)*(1 - 0.5*Alfa)*(Smooth[shift] - 2*Smooth[shift+1] + Smooth[shift+2]) + 2*(1-Alfa)*Cycle[shift+1] - (1-Alfa)*(1-Alfa)*Cycle[shift+2];
	if(shift > Bars - 7) Cycle[shift] = (aPrice(0,shift) - 2*aPrice(1,shift) + aPrice(2,shift))/4;  
	
	Q1[0] = (0.0962*Cycle[shift] + 0.5769*Cycle[shift+2] - 0.5769*Cycle[shift+4] - 0.0962*Cycle[shift+6])*(0.5+0.08*iPeriod[1]);
   I1[0] = Cycle[shift+3];  
	
	if(Q1[0] != 0 && Q1[1] != 0) 
	DeltaPhase[shift] = (I1[0]/Q1[0] - I1[1]/Q1[1])/(1+I1[0]*I1[1]/(Q1[0]*Q1[1]));		
	if(DeltaPhase[shift] < 0.1) DeltaPhase[shift] = 0.1;  
	if(DeltaPhase[shift] > 1.1) DeltaPhase[shift] = 1.1;
	double MedianDelta = Median(DeltaPhase,5,shift);

	if(MedianDelta == 0) double DC = 15; else DC = 6.28318/MedianDelta + 0.5;
	iPeriod[0] = 0.33*DC + 0.67*iPeriod[1];
	cPeriod[shift] = 0.15*iPeriod[0] + 0.85*cPeriod[shift+1];
   
      if(counted_bars < 1 && shift > 0)
      {
      Q1[1] = Q1[0];
      I1[1] = I1[0];
      iPeriod[1] = iPeriod[0];
      prevbars   = Bars;
      }   
   
   }
   
	return(0);	
}

double Median(double price[],int per,int bar)
{
   double array[];
   ArrayResize(array,per);
   
   for(int i = 0; i < per;i++) array[i] = price[bar+i];
   ArraySort(array);
   
   int num = MathRound(0.5*(per-1)); 
   if(MathMod(per,2)>0) double median = array[num]; else median = 0.5*(array[num]+array[num+1]);
   
   return(median); 
}

double aPrice(int d,int bar)
{
   return(iMA(NULL,0,1,0,0,Price,bar+d));
}   		